/**************************************************************************
*   file name   : definition of R8C14-15 & R8C16-17 SFR      V1.01        *
***************************************************************************/

/********************************************************
*   declare SFR addresses                               *
********************************************************/

#pragma ADDRESS     pm0_addr    0004H       /* Processor mode register 0 */
#pragma ADDRESS     pm1_addr    0005H       /* Processor mode register 1 */
#pragma ADDRESS     cm0_addr    0006H       /* System clock control register 0 */
#pragma ADDRESS     cm1_addr    0007H       /* System clock control register 1 */
#pragma ADDRESS     ocd_addr    000cH       /* System clock control register */
#pragma ADDRESS     hra0_addr   0020H       /* Highspeed Ring OSC register 0 */
#pragma ADDRESS     hra1_addr   0021H       /* Highspeed Ring OSC register 1 */
#pragma ADDRESS     hra2_addr   0022H       /* Highspeed Ring OSC register 2 */
#pragma ADDRESS     wdtr_addr   000dH       /* Watchdog timer reset register */
#pragma ADDRESS     wdts_addr   000eH       /* Watchdog timer start register */
#pragma ADDRESS     wdc_addr    000fH       /* Watchdog timer control register */

#pragma ADDRESS     prcr_addr   000aH       /* Protect register */

#pragma ADDRESS     cspr_addr   001cH       /* CountSource Protect register */

#pragma ADDRESS     aier_addr   0009H       /* Address match interrupt enable register */
#pragma ADDRESS     rmad0_addr  0010H       /* Address match interrupt register 0 */
#pragma ADDRESS     rmad1_addr  0014H       /* Address match interrupt register 1 */

#pragma ADDRESS     vca1_addr   0031H       /* Voltage Detect register */
#pragma ADDRESS     vca2_addr   0032H       /* Voltage Detect register */
#pragma ADDRESS     vw1c_addr   0036H       /* Voltage Detect register */
#pragma ADDRESS     vw2c_addr   0037H       /* Voltage Detect register */

#pragma ADDRESS     int0ic_addr 005dH       /* INT0~ interrupt control register */
#pragma ADDRESS     int1ic_addr 0059H       /* INT1~ interrupt control register */
#pragma ADDRESS     int3ic_addr 005aH       /* INT3~ interrupt control register */

#pragma ADDRESS     s0tic_addr  0051H       /* UART0 transmit interrupt control register */
#pragma ADDRESS     s0ric_addr  0052H       /* UART0 receive interrupt control register */
#pragma ADDRESS     s1tic_addr  0053H       /* UART1 transmit interrupt control register */
#pragma ADDRESS     s1ric_addr  0054H       /* UART1 receive interrupt control register */


#pragma ADDRESS     txic_addr   0056H       /* Timer X interrupt control register */
#pragma ADDRESS     tzic_addr   0058H       /* Timer Z interrupt control register */
#pragma ADDRESS     tcic_addr   005bH       /* Timer C interrupt control register */
#pragma ADDRESS     cmp0ic_addr 005cH       /* Timer C comp0 interrupt control register */
#pragma ADDRESS     cmp1ic_addr 0050H       /* Timer C comp1 interrupt control register */

#pragma ADDRESS     kupic_addr  004dH       /* Key input interrupt control register */
#pragma ADDRESS     adic_addr   004eH       /* A-D conversion interrupt control register */

#pragma ADDRESS     ssuaic_addr   004fH       /* SSU interrupt control register */
#pragma ADDRESS     iic2aic_addr  004fH       /* IIC interrupt control register */

#pragma ADDRESS     inten_addr  0096H       /* INT0-3 Enable control register */
#pragma ADDRESS     int0f_addr  0096H       /* INT0 Filter control register */
#pragma ADDRESS     kien_addr   0098H       /* Key enable control register */

#pragma ADDRESS     tx_addr     008dH       /* Timer X register */
#pragma ADDRESS     prex_addr   008cH       /* Timer X prescaler register */
#pragma ADDRESS     txmr_addr   008bH       /* Timer X mode register */

#pragma ADDRESS     tzpr_addr   0087H       /* Timer Z primary register */
#pragma ADDRESS     tzsc_addr   0086H       /* Timer Z secondary register */
#pragma ADDRESS     prez_addr   0085H       /* Timer Z prescaler register */

#pragma ADDRESS     tzmr_addr   0080H       /* Timer YZ mode register */
#pragma ADDRESS     tzoc_addr   008aH       /* Timer YZ output control register */
#pragma ADDRESS     pum_addr    0084H       /* Timer YZ Wave control register */
#pragma ADDRESS     tcss_addr   008eH       /* Timer count source register */

#pragma ADDRESS     tc_addr     0090H       /* Timer C register */
#pragma ADDRESS     tm0_addr    009cH       /* Timer C capture0 register */
#pragma ADDRESS     tm1_addr    009eH       /* Timer C capture1 register */
#pragma ADDRESS     tcc0_addr   009aH       /* Timer C control0 register */
#pragma ADDRESS     tcc1_addr   009bH       /* Timer C control1 register */
#pragma ADDRESS     tcout_addr  00ffH       /* Timer C output control register */

#pragma ADDRESS     u0tb_addr   00a2H       /* UART0 transmit buffer register */
#pragma ADDRESS     u0rb_addr   00a6H       /* UART0 receive buffer register */
#pragma ADDRESS     u0brg_addr  00a1H       /* UART0 bit rate generator */
#pragma ADDRESS     u0mr_addr   00a0H       /* UART0 transmit/receive mode register */
#pragma ADDRESS     u0c0_addr   00a4H       /* UART0 transmit/receive control register 0 */
#pragma ADDRESS     u0c1_addr   00a5H       /* UART0 transmit/receive control register 1 */

#pragma ADDRESS     u1tb_addr   00aaH       /* UART1 transmit buffer register */
#pragma ADDRESS     u1rb_addr   00aeH       /* UART1 receive buffer register */
#pragma ADDRESS     u1brg_addr  00a9H       /* UART1 bit rate generator */
#pragma ADDRESS     u1mr_addr   00a8H       /* UART1 transmit/receive mode register */
#pragma ADDRESS     u1c0_addr   00acH       /* UART1 transmit/receive control register 0 */
#pragma ADDRESS     u1c1_addr   00adH       /* UART1 transmit/receive control register 1 */
#pragma ADDRESS     ucon_addr   00b0H       /* UART transmit/receive control register 2 */


/* SSU  R8C14_15 */
#pragma ADDRESS     sscrh_addr   00b8H      /* SS */
#pragma ADDRESS     sscrl_addr   00b9H      /* SS */
#pragma ADDRESS     ssmr_addr    00baH      /* SS */
#pragma ADDRESS     sser_addr    00bbH      /* SS */
#pragma ADDRESS     sssr_addr    00bcH      /* SS */
#pragma ADDRESS     ssmr2_addr   00bdH      /* SS */
#pragma ADDRESS     sstdr_addr   00beH      /* SS */
#pragma ADDRESS     ssrdr_addr   00bfH      /* SS */

/* IIC  R8C16_17 */
#pragma ADDRESS     iicr1_addr   00b8H      /* IIC */
#pragma ADDRESS     iicr2_addr   00b9H      /* IIC */
#pragma ADDRESS     icmr_addr    00baH      /* IIC */
#pragma ADDRESS     icier_addr   00bbH      /* IIC */
#pragma ADDRESS     icsr_addr    00bcH      /* IIC */
#pragma ADDRESS     sr_addr      00bdH      /* IIC */
#pragma ADDRESS     icdrt_addr   00beH      /* IIC */
#pragma ADDRESS     icdrr_addr   00bfH      /* IIC */

#pragma ADDRESS     adcon0_addr 00d6H       /* A-D control register 0 */
#pragma ADDRESS     adcon1_addr 00d7H       /* A-D control register 1 */
#pragma ADDRESS     adcon2_addr 00d4H       /* A-D control register 2 */

#pragma ADDRESS     ad_addr     00c0H       /* A-D register */

#pragma ADDRESS     p1_addr     00e1H       /* Port P1 register */
#pragma ADDRESS     pd1_addr    00e3H       /* Port P1 direction register */
#pragma ADDRESS     p3_addr     00e5H       /* Port P3 register */
#pragma ADDRESS     pd3_addr    00e7H       /* Port P3 direction register */
#pragma ADDRESS     p4_addr     00e8H       /* Port P4 register */
#pragma ADDRESS     pd4_addr    00eaH       /* Port P4 direction register */

#pragma ADDRESS     pmr_addr   00f8H        /* SSI/IIC Port Mode */

#pragma ADDRESS     pur0_addr   00fcH       /* Pull-up control register 1 */
#pragma ADDRESS     pur1_addr   00fdH       /* Pull-up control register 2 */

#pragma ADDRESS     drr_addr    00feH       /* Port 1 drive curr control register */

#pragma ADDRESS     fmr0_addr   01b7H       /* Flash memory control register 0 */
#pragma ADDRESS     fmr1_addr   01b5H       /* Flash memory control register 1 */
#pragma ADDRESS     fmr4_addr   01b3H       /* Flash memory control register 2 */


/********************************************************
*   declare SFR bit                                     *
********************************************************/
struct bit8_def {
        char    b0:1;
        char    b1:1;
        char    b2:1;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
};
struct bit810_def {
        char    b10:2;
        char    b2:1;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
};
struct bit821_def {
        char    b0:1;
        char    b21:2;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
};
struct bit8210_def {
        char    b210:3;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
};
struct bit83210_def {
        char    b3210:4;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
};
struct bit82_def {
        char    b10:2;
        char    b32:2;
        char    b54:2;
        char    b76:2;
};
struct bit87621_def {
        char    b0:1;
        char    b21:2;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b76:2;
};
struct bit16_def {
        char    b0:1;
        char    b1:1;
        char    b2:1;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
        char    b8:1;
        char    b9:1;
        char    b10:1;
        char    b11:1;
        char    b12:1;
        char    b13:1;
        char    b14:1;
        char    b15:1;
};
struct bit20_def {
        char    b0:1;
        char    b1:1;
        char    b2:1;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
        char    b8:1;
        char    b9:1;
        char    b10:1;
        char    b11:1;
        char    b12:1;
        char    b13:1;
        char    b14:1;
        char    b15:1;
        char    b16:1;
        char    b17:1;
        char    b18:1;
        char    b19:1;
};

union byte_def{
    struct bit8_def bit;
    unsigned char byte;
};

union byte10_def{
    struct bit8_def bit;
    struct bit810_def bit10;
    unsigned char byte;
};

union byte21_def{
    struct bit8_def bit;
    struct bit821_def bit21;
    unsigned char byte;
};

union byte210_def{
    struct bit8_def bit;
    struct bit8210_def bit210;
    unsigned char byte;
};

union byte3210_def{
    struct bit8_def bit;
    struct bit83210_def bit3210;
    unsigned char byte;
};

union byte2_def{
    struct bit8_def bit;
    struct bit82_def bit2;
    unsigned char byte;
};

union byte7621_def{
    struct bit8_def bit;
    struct bit87621_def bit7621;
    unsigned char byte;
};

union word_def{
    struct bit16_def bit;
    struct{
        char    low;                /* low  8 bit */
        char    high;               /* high 8 bit */
    }byte;
    unsigned short  word;
};

union dword_def{
    struct bit20_def bit;
    struct{
        char    low;                /* low  8 bit */
        char    mid;                /* mid  8 bit */
        char    high;               /* high 8 bit */
        char    nc;                 /* non use */
    }byte;
    unsigned long   dword;
};

/*  Processor mode register 0  */
union byte_def pm0_addr;
#define		SFR_PM0		pm0_addr.byte
/*  Processor mode register 1  */
union byte_def pm1_addr;
#define		SFR_PM1		pm1_addr.byte

#define		SFR_PM_RST	pm0_addr.bit.b3     /* Software reset bit */
#define		SFR_PM_WDTS	pm1_addr.bit.b2     /* Watchdog reset/INT sel bit */

/* System clock control register 0 */
union byte_def cm0_addr;
#define		SFR_CM0		cm0_addr.byte

/* System clock control register 1 */
union byte_def cm1_addr;
#define		SFR_CM1		cm1_addr.byte

#define		SFR_CM_2	cm0_addr.bit.b2     /* WAIT peripheral function clock stop bit */
#define		SFR_CM_5	cm0_addr.bit.b5     /* Main clock stop bit */
#define		SFR_CM_6	cm0_addr.bit.b6     /* Main clock division select bit 0 */

#define		SFR_CM_10	cm1_addr.bit.b0     /* All clock stop control bit */
#define		SFR_CM_13	cm1_addr.bit.b3     /* Xin Port select bit */
#define		SFR_CM_14	cm1_addr.bit.b4     /* Rig OSC Disable bit */
#define		SFR_CM_15	cm1_addr.bit.b5     /* Xin-Xout drive capacity select bit */
#define		SFR_CM_16	cm1_addr.bit.b6     /* Main clock division select bit 1 */
#define		SFR_CM_17	cm1_addr.bit.b7     /* Main clock division select bit 1 */

/* System clock control register 1 */
union byte_def ocd_addr;
#define		SFR_OCD		ocd_addr.byte

#define		SFR_OCD_0	ocd_addr.bit.b0     /* OSC detect bit0 */
#define		SFR_OCD_1	ocd_addr.bit.b1     /* OSC detect bit1 */
#define		SFR_OCD_2	ocd_addr.bit.b2     /* SystemClock select bit */
#define		SFR_OCD_3	ocd_addr.bit.b3     /* Clock Monitor bit */

/* Protect register */
union byte_def prcr_addr;
#define		SFR_PRCR	prcr_addr.byte

#define		SFR_PRC_CM	prcr_addr.bit.b0    /* Enables writing to system clock control registers 0 and 1 */
#define		SFR_PRC_PM	prcr_addr.bit.b1    /* Enables writing to processor mode registers 0 and 1 */
#define		SFR_PRC_P	prcr_addr.bit.b2    /* Enables writing to port P0 direction register and SI/Oi control register(i=3,4) */
#define		SFR_PRC_V	prcr_addr.bit.b3    /* Enables writing to VCR2/DINT4 register */

/* Watchdog timer start register */
union byte_def wdts_addr;
#define		SFR_WDTS	wdts_addr.byte

/* Watchdog timer reset register */
union byte_def wdtr_addr;
#define		SFR_WDTR	wdtr_addr.byte

/* Watchdog timer control register */
union byte_def wdc_addr;
#define		SFR_WDC		wdc_addr.byte

#define		SFR_WDC_PR	wdc_addr.bit.b7			/* Prescaler select bit */

/* Count Source Protect register */
union byte_def cspr_addr;
#define		SFR_CSPR		cspr_addr.byte

#define		SFR_CSPR_O	cspr_addr.bit.b7		/*  */


/* int0ic */
union byte210_def int0ic_addr;
#define		SFR_INT0IC	int0ic_addr.byte

#define		SFR_INT0IC_ILVL		int0ic_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_INT0IC_ILVL0	int0ic_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_INT0IC_ILVL1	int0ic_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_INT0IC_ILVL2	int0ic_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_INT0IC_IR		int0ic_addr.bit.b3     /* Interrupt request bit */
#define		SFR_INT0IC_POL		int0ic_addr.bit.b4     /* Polarity select bit */

/* int1ic */
union byte210_def int1ic_addr;
#define		SFR_INT1IC	int1ic_addr.byte

#define		SFR_INT1IC_ILVL		int1ic_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_INT1IC_ILVL0	int1ic_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_INT1IC_ILVL1	int1ic_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_INT1IC_ILVL2	int1ic_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_INT1IC_IR		int1ic_addr.bit.b3     /* Interrupt request bit */

/* int3ic */
union byte210_def int3ic_addr;
#define		SFR_INT3IC	int3ic_addr.byte

#define		SFR_INT3IC_ILVL		int3ic_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_INT3IC_ILVL0	int3ic_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_INT3IC_ILVL1	int3ic_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_INT3IC_ILVL2	int3ic_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_INT3IC_IR		int3ic_addr.bit.b3     /* Interrupt request bit */

/* s0tic */
union byte210_def s0tic_addr;
#define		SFR_S0TIC		s0tic_addr.byte

#define		SFR_S0TIC_ILVL		s0tic_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_S0TIC_ILVL0		s0tic_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_S0TIC_ILVL1		s0tic_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_S0TIC_ILVL2		s0tic_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_S0TIC_IR		s0tic_addr.bit.b3     /* Interrupt request bit */

#define		SFR_U0TIC		s0tic_addr.byte

#define		SFR_U0TIC_ILVL		s0tic_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_U0TIC_ILVL0		s0tic_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_U0TIC_ILVL1		s0tic_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_U0TIC_ILVL2		s0tic_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_U0TIC_IR		s0tic_addr.bit.b3     /* Interrupt request bit */

/* s0ric */
union byte210_def s0ric_addr;
#define		SFR_S0RIC		s0ric_addr.byte

#define		SFR_S0RIC_ILVL		s0ric_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_S0RIC_ILVL0		s0ric_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_S0RIC_ILVL1		s0ric_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_S0RIC_ILVL2		s0ric_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_S0RIC_IR		s0ric_addr.bit.b3     /* Interrupt request bit */

#define		SFR_U0RIC		s0ric_addr.byte

#define		SFR_U0RIC_ILVL		s0ric_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_U0RIC_ILVL0		s0ric_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_U0RIC_ILVL1		s0ric_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_U0RIC_ILVL2		s0ric_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_U0RIC_IR		s0ric_addr.bit.b3     /* Interrupt request bit */

/* s1tic */
union byte210_def s1tic_addr;
#define		SFR_S1TIC		s1tic_addr.byte

#define		SFR_S1TIC_ILVL		s1tic_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_S1TIC_ILVL0		s1tic_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_S1TIC_ILVL1		s1tic_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_S1TIC_ILVL2		s1tic_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_S1TIC_IR		s1tic_addr.bit.b3     /* Interrupt request bit */

#define		SFR_U1TIC		s1tic_addr.byte

#define		SFR_U1TIC_ILVL		s1tic_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_U1TIC_ILVL0		s1tic_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_U1TIC_ILVL1		s1tic_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_U1TIC_ILVL2		s1tic_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_U1TIC_IR		s1tic_addr.bit.b3     /* Interrupt request bit */

/* s1ric */
union byte210_def s1ric_addr;
#define		SFR_S1RIC		s1ric_addr.byte

#define		SFR_S1RIC_ILVL		s1ric_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_S1RIC_ILVL0		s1ric_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_S1RIC_ILVL1		s1ric_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_S1RIC_ILVL2		s1ric_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_S1RIC_IR		s1ric_addr.bit.b3     /* Interrupt request bit */

#define		SFR_U1RIC		s1ric_addr.byte

#define		SFR_U1RIC_ILVL		s1ric_addr.bit210.b210  /* Interrupt priority level select bit */
#define		SFR_U1RIC_ILVL0		s1ric_addr.bit.b0     /* Interrupt priority level select bit */
#define		SFR_U1RIC_ILVL1		s1ric_addr.bit.b1     /* Interrupt priority level select bit */
#define		SFR_U1RIC_ILVL2		s1ric_addr.bit.b2     /* Interrupt priority level select bit */
#define		SFR_U1RIC_IR		s1ric_addr.bit.b3     /* Interrupt request bit */

/* tx ic */
union byte210_def txic_addr;
#define		SFR_TXIC		txic_addr.byte

#define		SFR_TXIC_ILEV		txic_addr.bit210.b210   /* Interrupt priority level select bit */
#define		SFR_TXIC_ILEV0		txic_addr.bit.b0       /* Interrupt priority level select bit */
#define		SFR_TXIC_ILEV1		txic_addr.bit.b1       /* Interrupt priority level select bit */
#define		SFR_TXIC_ILEV2		txic_addr.bit.b2       /* Interrupt priority level select bit */
#define		SFR_TXIC_IR			txic_addr.bit.b3       /* Interrupt request bit */

/* tz ic */
union byte210_def tzic_addr;
#define		SFR_TZIC		tzic_addr.byte

#define		SFR_TZIC_ILEV		tzic_addr.bit210.b210   /* Interrupt priority level select bit */
#define		SFR_TZIC_ILEV0		tzic_addr.bit.b0       /* Interrupt priority level select bit */
#define		SFR_TZIC_ILEV1		tzic_addr.bit.b1       /* Interrupt priority level select bit */
#define		SFR_TZIC_ILEV2		tzic_addr.bit.b2       /* Interrupt priority level select bit */
#define		SFR_TZIC_IR			tzic_addr.bit.b3       /* Interrupt request bit */

/* tc ic */
union byte210_def tcic_addr;
#define		SFR_TCIC		tcic_addr.byte

#define		SFR_TCIC_ILEV		tcic_addr.bit210.b210   /* Interrupt priority level select bit */
#define		SFR_TCIC_ILEV0		tcic_addr.bit.b0       /* Interrupt priority level select bit */
#define		SFR_TCIC_ILEV1		tcic_addr.bit.b1       /* Interrupt priority level select bit */
#define		SFR_TCIC_ILEV2		tcic_addr.bit.b2       /* Interrupt priority level select bit */
#define		SFR_TCIC_IR			tcic_addr.bit.b3       /* Interrupt request bit */

/* tc comp1 ic */
union byte210_def cmp0ic_addr;
#define		SFR_CMP0IC		cmp0ic_addr.byte

#define		SFR_CMP0IC_ILEV			cmp0ic_addr.bit210.b210   /* Interrupt priority level select bit */
#define		SFR_CMP0IC_ILEV0		cmp0ic_addr.bit.b0       /* Interrupt priority level select bit */
#define		SFR_CMP0IC_ILEV1		cmp0ic_addr.bit.b1       /* Interrupt priority level select bit */
#define		SFR_CMP0IC_ILEV2		cmp0ic_addr.bit.b2       /* Interrupt priority level select bit */
#define		SFR_CMP0IC_IR			cmp0ic_addr.bit.b3       /* Interrupt request bit */

/* tc comp2 ic */
union byte210_def cmp1ic_addr;
#define		SFR_CMP1IC		cmp1ic_addr.byte

#define		SFR_CMP1IC_ILEV			cmp1ic_addr.bit210.b210   /* Interrupt priority level select bit */
#define		SFR_CMP1IC_ILEV0		cmp1ic_addr.bit.b0       /* Interrupt priority level select bit */
#define		SFR_CMP1IC_ILEV1		cmp1ic_addr.bit.b1       /* Interrupt priority level select bit */
#define		SFR_CMP1IC_ILEV2		cmp1ic_addr.bit.b2       /* Interrupt priority level select bit */
#define		SFR_CMP1IC_IR			cmp1ic_addr.bit.b3       /* Interrupt request bit */

/* SSU ic */
union byte210_def ssuaic_addr;
#define		SFR_SSUAIC		ssuaic_addr.byte

#define		SFR_SSUAIC_ILEV		ssuaic_addr.bit210.b210   /* Interrupt priority level select bit */
#define		SFR_SSUAIC_ILEV0		ssuaic_addr.bit.b0       /* Interrupt priority level select bit */
#define		SFR_SSUAIC_ILEV1		ssuaic_addr.bit.b1       /* Interrupt priority level select bit */
#define		SFR_SSUAIC_ILEV2		ssuaic_addr.bit.b2       /* Interrupt priority level select bit */
#define		SFR_SSUAIC_IR		ssuaic_addr.bit.b3       /* Interrupt request bit */

/* IIC ic */
union byte210_def iic2aic_addr;
#define		SFR_IIC2AIC		iic2aic_addr.byte

#define		SFR_IIC2AIC_ILEV		iic2aic_addr.bit210.b210   /* Interrupt priority level select bit */
#define		SFR_IIC2AIC_ILEV0		iic2aic_addr.bit.b0       /* Interrupt priority level select bit */
#define		SFR_IIC2AIC_ILEV1		iic2aic_addr.bit.b1       /* Interrupt priority level select bit */
#define		SFR_IIC2AIC_ILEV2		iic2aic_addr.bit.b2       /* Interrupt priority level select bit */
#define		SFR_IIC2AIC_IR		iic2aic_addr.bit.b3       /* Interrupt request bit */


/* kupic */
union byte210_def kupic_addr;
#define		SFR_KUPIC		kupic_addr.byte

#define		SFR_KUPIC_ILEV		kupic_addr.bit210.b210   /* Interrupt priority level select bit */
#define		SFR_KUPIC_ILEV0		kupic_addr.bit.b0       /* Interrupt priority level select bit */
#define		SFR_KUPIC_ILEV1		kupic_addr.bit.b1       /* Interrupt priority level select bit */
#define		SFR_KUPIC_ILEV2		kupic_addr.bit.b2       /* Interrupt priority level select bit */
#define		SFR_KUPIC_IR		kupic_addr.bit.b3       /* Interrupt request bit */

/* adic */
union byte210_def adic_addr;
#define		SFR_ADIC		adic_addr.byte

#define		SFR_ADIC_ILEV		adic_addr.bit210.b210   /* Interrupt priority level select bit */
#define		SFR_ADIC_ILEV0		adic_addr.bit.b0       /* Interrupt priority level select bit */
#define		SFR_ADIC_ILEV1		adic_addr.bit.b1       /* Interrupt priority level select bit */
#define		SFR_ADIC_ILEV2		adic_addr.bit.b2       /* Interrupt priority level select bit */
#define		SFR_ADIC_IR			adic_addr.bit.b3       /* Interrupt request bit */

/* Address match interrupt enable register */
union byte_def aier_addr;
#define		SFR_AIER	aier_addr.byte

#define		SFR_AIER_0	aier_addr.bit.b0    /* Address match interrupt 0 enable bit */
#define		SFR_AIER_1	aier_addr.bit.b1    /* Address match interrupt 1 enable bit */

/* INT0 register */
union byte_def inten_addr;
#define		SFR_INTEN	inten_addr.byte

#define		SFR_INT0_EN		inten_addr.bit.b0    /* */
#define		SFR_INT0_PL		inten_addr.bit.b1    /* rise fall edge select */
#define		SFR_INT0_POL	int0ic_addr.bit.b4   /* Polarity select bit */

/* INT0 Filter register */
union byte10_def int0f_addr;
#define		SFR_INT0F	int0f_addr.byte

#define		SFR_INT0_F		int0f_addr.bit10.b10	/* INT0 Filter */
#define		SFR_INT0_F0		int0f_addr.bit.b0	/* INT0 Filter */
#define		SFR_INT0_F1		int0f_addr.bit.b1	/* INT0 Filter */


#define		SFR_INT1_POL	txmr_addr.bit.b2	/* rise fall edge select */
#define		SFR_INT1_SEL	ucon_addr.bit.b7    /* CNTR_SEL 1:P1_5 0:P1_7 */


#define		SFR_INT3_EN1	tcc0_addr.bit.b6	/* 1:INT3 */
#define		SFR_INT3_EN		tcc0_addr.bit.b7	/* 1:Ring128 0:INT3 */

#define		SFR_INT3_POL	tcc0_addr.bit.b3	/* rise fall edge select */
#define		SFR_INT3_PL		tcc0_addr.bit.b4	/* single both edge select */

#define		SFR_INT3_F	tcc1_addr.bit10.b10
#define		SFR_INT3_F0	tcc1_addr.bit.b0
#define		SFR_INT3_F1	tcc1_addr.bit.b1


/* KEY Enable register */
union byte_def kien_addr;
#define		SFR_KIEN	kien_addr.byte


unsigned char   tx_addr;              /* Timer X register */
#define		SFR_TX		tx_addr
unsigned char   prex_addr;            /* Timer X prescaler register */
#define		SFR_PREX	prex_addr
unsigned char   tzpr_addr;           /* Timer Z Primary register */
#define		SFR_TZPR	tzpr_addr
unsigned char   tzsc_addr;           /* Timer Z Secondary register */
#define		SFR_TZSC	tzsc_addr
unsigned char   prez_addr;            /* Timer Z prescaler register */
#define		SFR_PREZ	prez_addr

union byte_def   txmr_addr;            /* Timer X mode register */
#define		SFR_TXMR	txmr_addr.byte
union byte_def   tzmr_addr;           /* Timer Y/Z mode register */
#define		SFR_TZMR	tzmr_addr.byte
union byte_def   tzoc_addr;           /* Timer Y/Z output control register */
#define		SFR_TZOC	tzoc_addr.byte
union byte_def   pum_addr;             /* Timer Y/Z output control register */
#define		SFR_PUM		pum_addr.byte
union byte2_def   tcss_addr;            /* Timer Count source control register */
#define		SFR_TCSS	tcss_addr.byte

#define		SFR_TX_S	txmr_addr.bit.b3    /* Timer X count start flag */
#define		SFR_TZ_S	tzmr_addr.bit.b7   /* Timer Z count start flag */

#define		SFR_TX_OCNT	txmr_addr.bit.b4    /* Timer X out control */
#define		SFR_TZ_OCNT	tzoc_addr.bit.b2   /* Timer Z out control */
#define		SFR_TZ_OS	tzoc_addr.bit.b0   /* Timer Z oneshot */

#define		SFR_TZ_OPL	pum_addr.bit.b5     /* Timer Z outlevel latch */

#define		SFR_TZ_OSTG	pum_addr.bit.b6     /* INT0(Z) Oneshot Triger control */
#define		SFR_TZ_OSEG	pum_addr.bit.b7     /* INT0(Z) Oneshot Edge select */


#define		SFR_TX_MOD0	txmr_addr.bit.b0        /* Operation mode select bit */
#define		SFR_TX_MOD1	txmr_addr.bit.b1        /* Operation mode select bit */
#define		SFR_TX_MOD2	txmr_addr.bit.b5        /* Operation mode select bit */
#define		SFR_TX_R0EDG	txmr_addr.bit.b2
#define		SFR_TX_EDG		txmr_addr.bit.b6
#define		SFR_TX_UND		txmr_addr.bit.b7

#define		SFR_TX_CK	tcss_addr.bit2.b10       /* Count source select bit */
#define		SFR_TX_CK0	tcss_addr.bit.b0       /* Count source select bit */
#define		SFR_TX_CK1	tcss_addr.bit.b1       /* Count source select bit */

#define		SFR_TZ_MOD0		tzmr_addr.bit.b4        /* Operation mode select bit */
#define		SFR_TZ_MOD1		tzmr_addr.bit.b5        /* Operation mode select bit */
#define		SFR_TZ_WC		tzmr_addr.bit.b6

#define		SFR_TZ_CK	tcss_addr.bit2.b54       /* Count source select bit */
#define		SFR_TZ_CK0	tcss_addr.bit.b4       /* Count source select bit */
#define		SFR_TZ_CK1	tcss_addr.bit.b5       /* Count source select bit */

unsigned short   tc_addr;           /* Timer C register */
#define		SFR_TC		tc_addr
unsigned short   tm0_addr;          /* Timer C caputure0 register */
#define		SFR_TM0		tm0_addr
unsigned short   tm1_addr;          /* Timer C caputure1 register */
#define		SFR_TM1		tm1_addr

union byte7621_def   tcc0_addr;          /* Timer C control 0 register */
#define		SFR_TCC0	tcc0_addr.byte

#define		SFR_TC_S	tcc0_addr.bit.b0    /* Timer C count start flag */
#define		SFR_TC_CK	tcc0_addr.bit7621.b21    /* Count source select bit */
#define		SFR_TC_CK0	tcc0_addr.bit.b1    /* Count source select bit */
#define		SFR_TC_CK1	tcc0_addr.bit.b2    /* Count source select bit */

#define		SFR_TCC_00	tcc0_addr.bit.b0
#define		SFR_TCC_01	tcc0_addr.bit.b1
#define		SFR_TCC_02	tcc0_addr.bit.b2
#define		SFR_TCC_03	tcc0_addr.bit.b3
#define		SFR_TCC_04	tcc0_addr.bit.b4
#define		SFR_TCC_05	tcc0_addr.bit.b5
#define		SFR_TCC_06	tcc0_addr.bit.b6
#define		SFR_TCC_07	tcc0_addr.bit.b7

union byte10_def   tcc1_addr;          /* Timer C control 1 register */
#define		SFR_TCC1	tcc1_addr.byte

#define		SFR_TCC_10	tcc1_addr.bit.b0
#define		SFR_TCC_11	tcc1_addr.bit.b1
#define		SFR_TCC_12	tcc1_addr.bit.b2
#define		SFR_TCC_13	tcc1_addr.bit.b3
#define		SFR_TCC_14	tcc1_addr.bit.b4
#define		SFR_TCC_15	tcc1_addr.bit.b5
#define		SFR_TCC_16	tcc1_addr.bit.b6
#define		SFR_TCC_17	tcc1_addr.bit.b7

union byte_def   tcout_addr;          /* Timer C out control register */
#define		SFR_TCOUT	tcout_addr.byte

#define		SFR_TCOUT_0	tcout_addr.bit.b0
#define		SFR_TCOUT_1	tcout_addr.bit.b1
#define		SFR_TCOUT_2	tcout_addr.bit.b2
#define		SFR_TCOUT_3	tcout_addr.bit.b3
#define		SFR_TCOUT_4	tcout_addr.bit.b4
#define		SFR_TCOUT_5	tcout_addr.bit.b5
#define		SFR_TCOUT_6	tcout_addr.bit.b6
#define		SFR_TCOUT_7	tcout_addr.bit.b7


union word_def u0rb_addr;				/* u0rb */
#define		SFR_U0RB	u0rb_addr.word
#define		SFR_U0RBL	u0rb_addr.byte.low
#define		SFR_U0RBH	u0rb_addr.byte.high

#define		SFR_U0_OER	u0rb_addr.bit.12           /* Overrun error flag */
#define		SFR_U0_FER	u0rb_addr.bit.13           /* Framing error flag*/
#define		SFR_U0_PER	u0rb_addr.bit.14           /* Parity error flag */
#define		SFR_U0_SUM	u0rb_addr.bit.15           /* Error sum flag */

union word_def u1rb_addr;				/* u0rb */
#define		SFR_U1RB	u1rb_addr.word
#define		SFR_U1RBL	u1rb_addr.byte.low
#define		SFR_U1RBH	u1rb_addr.byte.high

#define		SFR_U1_OER	u1rb_addr.bit.b12           /* Overrun error flag */
#define		SFR_U1_FER	u1rb_addr.bit.b13           /* Framing error flag*/
#define		SFR_U1_PER	u1rb_addr.bit.b14           /* Parity error flag */
#define		SFR_U1_SUM	u1rb_addr.bit.b15           /* Error sum flag */

union word_def u0tb_addr;
#define		SFR_U0TB	u0tb_addr.word              /* UART0 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define		SFR_U0TBL	u0tb_addr.byte.low              /* UART0 Transmit buffer register low  8 bit */
#define		SFR_U0TBH	u0tb_addr.byte.high             /* UART0 Transmit buffer register high 8 bit */

union word_def u1tb_addr;
#define		SFR_U1TB	u1tb_addr.word              /* UART1 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define		SFR_U1TBL	u1tb_addr.byte.low              /* UART1 Transmit buffer register low  8 bit */
#define		SFR_U1TBH	u1tb_addr.byte.high             /* UART1 Transmit buffer register high 8 bit */

union byte_def u0brg_addr;
#define		SFR_U0BRG	u0brg_addr.byte

union byte_def u1brg_addr;
#define		SFR_U1BRG	u1brg_addr.byte

union byte210_def u0mr_addr;
#define		SFR_U0MR	u0mr_addr.byte

#define		SFR_U0_SMD		u0mr_addr.bit210.b210      /* Serial I/O mode select bit */
#define		SFR_U0_SMD0		u0mr_addr.bit.b0           /* Serial I/O mode select bit */
#define		SFR_U0_SMD1		u0mr_addr.bit.b1           /* Serial I/O mode select bit */
#define		SFR_U0_SMD2		u0mr_addr.bit.b2           /* Serial I/O mode select bit */
#define		SFR_U0_CKDIR	u0mr_addr.bit.b3           /* Internal/external clock select bit */
#define		SFR_U0_STPS		u0mr_addr.bit.b4           /* Stop bit length select bit */
#define		SFR_U0_PRY		u0mr_addr.bit.b5           /* Odd/even parity select bit */
#define		SFR_U0_PRYE		u0mr_addr.bit.b6           /* Parity enable bit */

union byte210_def u1mr_addr;
#define		SFR_U1MR	u1mr_addr.byte

#define		SFR_U1_SMD		u1mr_addr.bit210.b210       /* Serial I/O mode select bit */
#define		SFR_U1_SMD0		u1mr_addr.bit.b0            /* Serial I/O mode select bit */
#define		SFR_U1_SMD1		u1mr_addr.bit.b1            /* Serial I/O mode select bit */
#define		SFR_U1_SMD2		u1mr_addr.bit.b2            /* Serial I/O mode select bit */
#define		SFR_U1_CKDIR	u1mr_addr.bit.b3            /* Internal/external clock select bit */
#define		SFR_U1_STPS		u1mr_addr.bit.b4            /* Stop bit length select bit */
#define		SFR_U1_PRY		u1mr_addr.bit.b5            /* Odd/even parity select bit */
#define		SFR_U1_PRYE		u1mr_addr.bit.b6            /* Parity enable bit */

union byte10_def u0c0_addr;
#define		SFR_U0C0	u0c0_addr.byte

#define		SFR_U0_CLK		u0c0_addr.bit10.b10          /* BRG count source select bit */
#define		SFR_U0_CLK0		u0c0_addr.bit.b0            /* BRG count source select bit */
#define		SFR_U0_CLK1		u0c0_addr.bit.b1            /* BRG count source select bit */
#define		SFR_U0_TXEPT	u0c0_addr.bit.b3            /* Transmit register empty flag */
#define		SFR_U0_NCH		u0c0_addr.bit.b5            /* Data output select bit */
#define		SFR_U0_CKPOL	u0c0_addr.bit.b6            /* CLK polarity select bit */
#define		SFR_U0_UFORM	u0c0_addr.bit.b7            /* Transfer format select bit */

union byte10_def u1c0_addr;
#define		SFR_U1C0	u1c0_addr.byte

#define		SFR_U1_CLK		u1c0_addr.bit10.b10          /* BRG count source select bit */
#define		SFR_U1_CLK0		u1c0_addr.bit.b0            /* BRG count source select bit */
#define		SFR_U1_CLK1		u1c0_addr.bit.b1            /* BRG count source select bit */
#define		SFR_U1_TXEPT	u1c0_addr.bit.b3            /* Transmit register empty flag */
#define		SFR_U1_NCH		u1c0_addr.bit.b5            /* Data output select bit */
#define		SFR_U1_CKPOL	u1c0_addr.bit.b6            /* CLK polarity select bit */
#define		SFR_U1_UFORM	u1c0_addr.bit.b7            /* Transfer format select bit */

union byte_def u0c1_addr;				/* u0c1 */
#define		SFR_U0C1	u0c1_addr.byte

#define		SFR_U0_TE	u0c1_addr.bit.b0            /* Transmit enable bit */
#define		SFR_U0_TI	u0c1_addr.bit.b1            /* Transmit buffer empty flag */
#define		SFR_U0_RE	u0c1_addr.bit.b2            /* Receive enable bit */
#define		SFR_U0_RI	u0c1_addr.bit.b3            /* Receive complete flag */

union byte_def u1c1_addr;				/* u1c1 */
#define		SFR_U1C1	u1c1_addr.byte

#define		SFR_U1_TE	u1c1_addr.bit.b0            /* Transmit enable bit */
#define		SFR_U1_TI	u1c1_addr.bit.b1            /* Transmit buffer empty flag */
#define		SFR_U1_RE	u1c1_addr.bit.b2            /* Receive enable bit */
#define		SFR_U1_RI	u1c1_addr.bit.b3            /* Receive complete flag */

/* UART transmit/receive control register 2 */
union byte_def ucon_addr;
#define		SFR_UCON	ucon_addr.byte

#define		SFR_U0_IRS		ucon_addr.bit.b0    /* UART0 transmit interrupt cause select bit */
#define		SFR_U1_IRS		ucon_addr.bit.b1    /* UART1 transmit interrupt cause select bit */
#define		SFR_U0_RRM		ucon_addr.bit.b2    /* UART0 continuous receive mode enable bit */
//#define		SFR_U1_TXD1SEL	ucon_addr.bit.b5    /*  */
//#define		SFR_U1_TXD1EN	ucon_addr.bit.b6    /*  */
#define		SFR_U1_CNTRSEL	ucon_addr.bit.b7    /*  */


/* Flash memory control register 0 */
union byte_def fmr0_addr;
#define		SFR_FMR0	fmr0_addr.byte

#define		SFR_FMR_00	fmr0_addr.bit.b0             /* RY/BY~ status bit */
#define		SFR_FMR_01	fmr0_addr.bit.b1             /* CPU rewrite mode select bit */
#define		SFR_FMR_02	fmr0_addr.bit.b2             /* WR_enable Block0/1 bit */
#define		SFR_FMR_STP	fmr0_addr.bit.b3             /* Flash memory stop bit */
#define		SFR_FMR_06	fmr0_addr.bit.b6             /* ProgramStatus bit */
#define		SFR_FMR_07	fmr0_addr.bit.b7             /* EraseStatus bit */

/* Flash memory control register 1 */
union byte_def fmr1_addr;
#define		SFR_FMR1	fmr1_addr.byte

#define		SFR_FMR_11	fmr1_addr.bit.b1             /* EW1 mode select bit */
#define		SFR_FMR_15	fmr1_addr.bit.b5             /* Block0 write enable bit */
#define		SFR_FMR_16	fmr1_addr.bit.b6             /* Block1 write enable bit */

/* Flash memory control register 4 */
union byte_def fmr4_addr;
#define		SFR_FMR4	fmr4_addr.byte

#define		SFR_FMR_40	fmr4_addr.bit.b0             /* EraseSuspend enable bit */
#define		SFR_FMR_41	fmr4_addr.bit.b1             /* EraseSuspend Request bit */
#define		SFR_FMR_46	fmr4_addr.bit.b6             /* ReadStatus enable bit */

#define		SFR_FMR_RDY	fmr0_addr.bit.b0             /* RY/BY~ status bit */
#define		SFR_FMR_EN	fmr0_addr.bit.b1             /* CPU rewrite mode select bit */
#define		SFR_FMR_PRS	fmr0_addr.bit.b6             /* ProgramStatus bit */
#define		SFR_FMR_ERS	fmr0_addr.bit.b7             /* EraseStatus bit */
#define		SFR_FMR_EW1	fmr1_addr.bit.b1             /* EW1 mode select bit */


union word_def ad_addr;
#define		SFR_AD		ad_addr.word               /* A-D register  16 bit */
#define		SFR_ADL		ad_addr.byte.low           /* A-D register  low  8 bit */
#define		SFR_ADH		ad_addr.byte.high          /* A-D register  high 8 bit */

/* A-D control register 0 */
union byte210_def adcon0_addr;
#define		SFR_ADCON0	adcon0_addr.byte

#define		SFR_AD_CH		adcon0_addr.bit210.b210  /* Analog input pin select bit */
#define		SFR_AD_CH0		adcon0_addr.bit.b0  /* Analog input pin select bit */
#define		SFR_AD_CH1		adcon0_addr.bit.b1  /* Analog input pin select bit */
#define		SFR_AD_CH2		adcon0_addr.bit.b2  /* Analog input pin select bit */
#define		SFR_AD_MD		adcon0_addr.bit.b3  /* A-D operation mode select bit */
#define		SFR_AD_ADGSEL	adcon0_addr.bit.b4  /* A-D group P0/P1 select bit 0 */
#define		SFR_AD_CAP		adcon0_addr.bit.b5  /*  */
#define		SFR_AD_ST		adcon0_addr.bit.b6  /* A-D conversion start flag */
#define		SFR_AD_CKS0		adcon0_addr.bit.b7  /* A-D Clock select bit 0 */

/* A-D control register 1 */
union byte_def adcon1_addr;
#define		SFR_ADCON1	adcon1_addr.byte

#define		SFR_AD_BITS		adcon1_addr.bit.b3  /* 8/10-bit mode select bit */
#define		SFR_AD_CKS1		adcon1_addr.bit.b4  /* A-D Clock select bit 1 */
#define		SFR_AD_VCUT		adcon1_addr.bit.b5  /* Vref connect bit */

/* A-D control register 2 */
union byte_def adcon2_addr;
#define		SFR_ADCON2	adcon2_addr.byte

#define		SFR_AD_SMP	adcon2_addr.bit.b0  /* A-D conversion method select bit */


/* Port P1 register */
union byte_def p1_addr;
#define		SFR_P1		p1_addr.byte

#define		SFR_P1_0	p1_addr.bit.b0      /* Port P10 register */
#define		SFR_P1_1	p1_addr.bit.b1      /* Port P11 register */
#define		SFR_P1_2	p1_addr.bit.b2      /* Port P12 register */
#define		SFR_P1_3	p1_addr.bit.b3      /* Port P13 register */
#define		SFR_P1_4	p1_addr.bit.b4      /* Port P14 register */
#define		SFR_P1_5	p1_addr.bit.b5      /* Port P15 register */
#define		SFR_P1_6	p1_addr.bit.b6      /* Port P16 register */
#define		SFR_P1_7	p1_addr.bit.b7      /* Port P17 register */

/* Port P1 direction register */
union byte_def pd1_addr;
#define		SFR_PD1		pd1_addr.byte
#define		SFR_P1D		pd1_addr.byte

#define		SFR_P1D_0	pd1_addr.bit.b0     /* Port P10 direction register */
#define		SFR_P1D_1	pd1_addr.bit.b1     /* Port P11 direction register */
#define		SFR_P1D_2	pd1_addr.bit.b2     /* Port P12 direction register */
#define		SFR_P1D_3	pd1_addr.bit.b3     /* Port P13 direction register */
#define		SFR_P1D_4	pd1_addr.bit.b4     /* Port P14 direction register */
#define		SFR_P1D_5	pd1_addr.bit.b5     /* Port P15 direction register */
#define		SFR_P1D_6	pd1_addr.bit.b6     /* Port P16 direction register */
#define		SFR_P1D_7	pd1_addr.bit.b7     /* Port P17 direction register */

/* Port P3 register */
union byte_def p3_addr;
#define		SFR_P3		p3_addr.byte

#define		SFR_P3_3	p3_addr.bit.b3      /* Port P33 register */
#define		SFR_P3_4	p3_addr.bit.b4      /* Port P33 register */
#define		SFR_P3_5	p3_addr.bit.b5      /* Port P33 register */
#define		SFR_P3_7	p3_addr.bit.b7      /* Port P37 register */

/* Port P3 direction register */
union byte_def pd3_addr;
#define		SFR_PD3		pd3_addr.byte
#define		SFR_P3D		pd3_addr.byte

#define		SFR_P3D_3	pd3_addr.bit.b3     /* Port P33 direction register */
#define		SFR_P3D_4	pd3_addr.bit.b4     /* Port P33 direction register */
#define		SFR_P3D_5	pd3_addr.bit.b5     /* Port P33 direction register */
#define		SFR_P3D_7	pd3_addr.bit.b7     /* Port P37 direction register */

/* Port P4 register */
union byte_def p4_addr;
#define		SFR_P4		p4_addr.byte

#define		SFR_P4_2	p4_addr.bit.b2      /* Port P42 register */
#define		SFR_P4_5	p4_addr.bit.b5      /* Port P45 register */
#define		SFR_P4_6	p4_addr.bit.b6      /* Port P46 register */
#define		SFR_P4_7	p4_addr.bit.b7      /* Port P47 register */

/* Port P4 direction register */
union byte_def pd4_addr;
#define		SFR_PD4		pd4_addr.byte
#define		SFR_P4D		pd4_addr.byte

#define		SFR_P4D_5	pd4_addr.bit.b5     /* Port P45 direction register */

/* Pull-up control register 0 */
union byte_def pur0_addr;
#define		SFR_PUR0	pur0_addr.byte

#define		SFR_P1_PUL	pur0_addr.bit.b2    /* P10 to P13 pull-up */
#define		SFR_P1_PUH	pur0_addr.bit.b3    /* P14 to P17 pull-up */
#define		SFR_P3_PUL	pur0_addr.bit.b6    /* P30 to P33 pull-up */
#define		SFR_P3_PUH	pur0_addr.bit.b7    /* P34 to P37 pull-up */

/* Pull-up control register 1 */
union byte_def pur1_addr;
#define		SFR_PUR1	pur1_addr.byte

#define		SFR_P4_PUH	pur1_addr.bit.b1    /* P45 pull-up */

/* Port1 Drive current control register */
union byte_def drr_addr;
#define		SFR_DRR		drr_addr.byte

#define		SFR_P1DRR_0	drr_addr.bit.b0     /* Port P1 control register */
#define		SFR_P1DRR_1	drr_addr.bit.b1     /* Port P1 control register */
#define		SFR_P1DRR_2	drr_addr.bit.b2     /* Port P1 control register */
#define		SFR_P1DRR_3	drr_addr.bit.b3     /* Port P1 control register */


/* SSU/IIC Select register R8C1A/B */
union byte_def pmr_addr;
#define		SFR_PMR		pmr_addr.byte

#define		SFR_PMR_SSISEL	pmr_addr.bit.b3
#define		SFR_PMR_IICSEL	pmr_addr.bit.b7


/* SSU   R8C14_15 */

/* SSU control register H/L */
union byte210_def sscrh_addr;
#define		SFR_SSCRH		sscrh_addr.byte

#define		SFR_SS_CKS		sscrh_addr.bit210.b210
#define		SFR_SS_CKS0		sscrh_addr.bit.b0
#define		SFR_SS_CKS1		sscrh_addr.bit.b1
#define		SFR_SS_CKS2		sscrh_addr.bit.b2
#define		SFR_SS_MSS		sscrh_addr.bit.b5
#define		SFR_SS_RSSTP	sscrh_addr.bit.b6

union byte_def sscrl_addr;
#define		SFR_SSCRL		sscrl_addr.byte

#define		SFR_SS_SRES		sscrh_addr.bit.b1
#define		SFR_SS_SOLP		sscrh_addr.bit.b4
#define		SFR_SS_SOL		sscrh_addr.bit.b5

/* SSU mode register */
union byte210_def ssmr_addr;
#define		SFR_SSMR		ssmr_addr.byte

#define		SFR_SS_BC		ssmr_addr.bit210.b210
#define		SFR_SS_BC0		ssmr_addr.bit.b0
#define		SFR_SS_BC1		ssmr_addr.bit.b1
#define		SFR_SS_BC2		ssmr_addr.bit.b2
#define		SFR_SS_CPHS		ssmr_addr.bit.b5
#define		SFR_SS_CPOS		ssmr_addr.bit.b6
#define		SFR_SS_MLS		ssmr_addr.bit.b7

union byte2_def ssmr2_addr;
#define		SFR_SSMR2		ssmr2_addr.byte

#define		SFR_SS_SSUMS	ssmr2_addr.bit.b0
#define		SFR_SS_CSOS		ssmr2_addr.bit.b1
#define		SFR_SS_SOOS		ssmr2_addr.bit.b2
#define		SFR_SS_SCKOS	ssmr2_addr.bit.b3
#define		SFR_SS_CSS		ssmr2_addr.bit2.b54
#define		SFR_SS_CSS0		ssmr2_addr.bit.b4
#define		SFR_SS_CSS1		ssmr2_addr.bit.b5
#define		SFR_SS_SCKS		ssmr2_addr.bit.b6
#define		SFR_SS_BIDE		ssmr2_addr.bit.b7

union byte_def sser_addr;
#define		SFR_SSER		sser_addr.byte

#define		SFR_SS_CEIE		sser_addr.bit.b0
#define		SFR_SS_RE		sser_addr.bit.b3
#define		SFR_SS_TE		sser_addr.bit.b4
#define		SFR_SS_RIE		sser_addr.bit.b5
#define		SFR_SS_TEIE		sser_addr.bit.b6
#define		SFR_SS_TIE		sser_addr.bit.b7

union byte_def sssr_addr;
#define		SFR_SSSR		sssr_addr.byte

#define		SFR_SS_CE		sssr_addr.bit.b0
#define		SFR_SS_ORER		sssr_addr.bit.b2
#define		SFR_SS_RDRF		sssr_addr.bit.b5
#define		SFR_SS_RI		sssr_addr.bit.b5
#define		SFR_SS_TEND		sssr_addr.bit.b6
#define		SFR_SS_TXEPT	sssr_addr.bit.b6
#define		SFR_SS_TDRE		sssr_addr.bit.b7
#define		SFR_SS_TI		sssr_addr.bit.b7

union byte_def sstdr_addr;
#define		SFR_SSTDR		sstdr_addr.byte
#define		SFR_SSTB		sstdr_addr.byte

union byte_def ssrdr_addr;
#define		SFR_SSRDR		ssrdr_addr.byte
#define		SFR_SSRB		ssrdr_addr.byte

/* IIC   R8C16_17 */

union sar_byte_def{				/* SAR register */
    struct{
        char    b0:1;              /*  */
        char    sva:7;              /*  */
    }bit;
    char    byte;
};

union byte3210_def iccr1_addr;
#define		SFR_ICCR1		iccr1_addr.byte

#define		SFR_IIC_CKS		iccr1_addr.bit3210.b3210
#define		SFR_IIC_CKS0	iccr1_addr.bit.b0
#define		SFR_IIC_CKS1	iccr1_addr.bit.b1
#define		SFR_IIC_CKS2	iccr1_addr.bit.b2
#define		SFR_IIC_CKS3	iccr1_addr.bit.b3
#define		SFR_IIC_TRS		iccr1_addr.bit.b4
#define		SFR_IIC_MST		iccr1_addr.bit.b5
#define		SFR_IIC_RCVD	iccr1_addr.bit.b6
#define		SFR_IIC_ICE		iccr1_addr.bit.b7

union byte_def iccr2_addr;
#define		SFR_ICCR2		iccr2_addr.byte

#define		SFR_IIC_RST		iccr2_addr.bit.b1
#define		SFR_IIC_SCL0	iccr2_addr.bit.b3
#define		SFR_IIC_SDAOP	iccr2_addr.bit.b4
#define		SFR_IIC_SDAO	iccr2_addr.bit.b5
#define		SFR_IIC_SCP		iccr2_addr.bit.b6
#define		SFR_IIC_BBSY	iccr2_addr.bit.b7

union byte210_def icmr_addr;
#define		SFR_ICMR		icmr_addr.byte

#define		SFR_IIC_BC		icmr_addr.bit210.b210
#define		SFR_IIC_BC0		icmr_addr.bit.b0
#define		SFR_IIC_BC1		icmr_addr.bit.b1
#define		SFR_IIC_BC2		icmr_addr.bit.b2
#define		SFR_IIC_BCWP	icmr_addr.bit.b3
#define		SFR_IIC_WAIT	icmr_addr.bit.b6
#define		SFR_IIC_MLS		icmr_addr.bit.b7

union byte_def icier_addr;
#define		SFR_ICIER		icier_addr.byte

#define		SFR_IIC_ACKBT	icier_addr.bit.b0
#define		SFR_IIC_ACKBR	icier_addr.bit.b1
#define		SFR_IIC_ACKE	icier_addr.bit.b2
#define		SFR_IIC_STIE	icier_addr.bit.b3
#define		SFR_IIC_NAKIE	icier_addr.bit.b4
#define		SFR_IIC_RIE		icier_addr.bit.b5
#define		SFR_IIC_TEIE	icier_addr.bit.b6
#define		SFR_IIC_TIE		icier_addr.bit.b7

union byte_def icsr_addr;
#define		SFR_ICSR		icsr_addr.byte

#define		SFR_IIC_ADZ		icsr_addr.bit.b0
#define		SFR_IIC_AAS		icsr_addr.bit.b1
#define		SFR_IIC_AL		icsr_addr.bit.b2
#define		SFR_IIC_STOP	icsr_addr.bit.b3
#define		SFR_IIC_NACKF	icsr_addr.bit.b4
#define		SFR_IIC_RDRF	icsr_addr.bit.b5
#define		SFR_IIC_TEND	icsr_addr.bit.b6
#define		SFR_IIC_TDRE	icsr_addr.bit.b7

union sar_byte_def sar_addr;
#define		SFR_SAR			sar_addr.byte

#define		SFR_IIC_FS		icmr_addr.bit.b0
#define		SFR_IIC_SVA		icmr_addr.bit.sva

union byte_def icdrt_addr;
#define		SFR_ICDRT		icdrt_addr.byte
#define		SFR_IICTB		icdrt_addr.byte

union byte_def icdrr_addr;
#define		SFR_ICDRR		icdrr_addr.byte
#define		SFR_IICRB		icdrr_addr.byte

#define ei()	_asm(" fset I")
#define di()	_asm(" fclr I")
#define nop()	_asm(" nop")
