// ****  sample programs for ATB-R8CQ_EX (c)AT-Laboratory  ****
// vO: UART_LCD.C
//  쐬t   : 2005/3/1
// vO̓e: UARTMLCD\TvvO
//  UARTMf[^LCDɕ\܂B
//  LCD\CugpĂ܂B
// ʐM|[gUART0|[g(COM0RS232CRlN^)
// ʐMp[^́A19200bps/8rbgf[^/peBȂ/Xgbvrbg1
// ύX̓\[X UART_init()֐ōs܂B

#include "R8C15.h"
#include "std_lcd.h"

#define UART	0		// gpUART|[g
// UART1gpꍇɂ̓fobOł܂B
#if UART==0
#define UART_MR		SFR_U0MR
#define UART__RE	SFR_U0_RE
#define UART__TE	SFR_U0_TE
#define UART__RI	SFR_U0_RI
#define UART__TI	SFR_U0_TI

#define UART_C0		SFR_U0C0
#define UART_C1		SFR_U0C1
#define UART_BRG	SFR_U0BRG
#define UART_RB		SFR_U0RB
#define UART_TB		SFR_U0TB

#define UART_RIC	SFR_U0RIC
#define UART_TIC	SFR_U0TIC
#endif

#if UART==1
#define UART_MR		SFR_U1MR
#define UART__RE	SFR_U1_RE
#define UART__TE	SFR_U1_TE
#define UART__RI	SFR_U1_RI
#define UART__TI	SFR_U1_TI

#define UART_C0		SFR_U1C0
#define UART_C1		SFR_U1C1
#define UART_BRG	SFR_U1BRG
#define UART_RB		SFR_U1RB
#define UART_TB		SFR_U1TB

#define UART_RIC	SFR_U1RIC
#define UART_TIC	SFR_U1TIC
#endif

				// 20M		16M
#define	BRG_57600	21	//	16
#define CNTR_57600	0	//	0
#define	BRG_38400	32	//	25
#define CNTR_38400	0	//	0
#define	BRG_19200	64	//	51
#define CNTR_19200	0	//	0
#define	BRG_9600		129	//	103
#define CNTR_9600	0	//	0
#define	BRG_4800		32	//	207
#define CNTR_4800	1	//	0
#define	BRG_2400		64	//	51
#define CNTR_2400	1	//	1
#define	BRG_1200		129	//	103
#define CNTR_1200	1	//	1
#define	BRG_600		64	//	207
#define CNTR_600		2	//	1
#define	BRG_300		129	//	103
#define CNTR_300		2	//	2

#define PAR_NONE	0
#define PAR_ODD		0b01000000
#define PAR_EVEN	0b01100000

#define STOP_1		0b00000000
#define STOP_2		0b00010000

#define BIT_7		0b00000100
#define BIT_8		0b00000101
#define BIT_9		0b00000110

// vg^Cv錾
void UART_init(void);
void putc_rs(unsigned int c);
void puts_rs(char *str);
int getc_rs(void);

// O[oϐ錾
#define RX_BUF_SIZE	100
unsigned char rx_buffer[RX_BUF_SIZE];	// MOobt@[
unsigned char rx_rd_ptr;		// Mǂݎ|C^[
unsigned char rx_wr_ptr;		// M݃|C^[

// U0|[g̏ꍇ̎M荞ݏ
void u0_rx_int(void)
#pragma interrupt u0_rx_int (vect=18)
{
#if UART==0
	rx_buffer[rx_wr_ptr]=(unsigned char)(UART_RB & 0xff);
	rx_wr_ptr++;
	if (rx_wr_ptr>=RX_BUF_SIZE)
		rx_wr_ptr=0;
#endif
}

// U1|[g̏ꍇ̎M荞ݏ
void u1_rx_int(void)
#pragma interrupt u1_rx_int (vect=20)
{
#if UART==1
	rx_buffer[rx_wr_ptr]=(unsigned char)(UART_RB & 0xff);
	rx_wr_ptr++;
	if (rx_wr_ptr>=RX_BUF_SIZE)
		rx_wr_ptr=0;
#endif
}

//
// UARTݒ 19200bps 8bits parity:none stop:1
void UART_init(void)
{
	UART_C0=  CNTR_19200;
	UART_BRG= BRG_19200;
	UART_MR=  PAR_NONE | STOP_1 | BIT_8;
	UART_RIC=6;		// INT LEVEL
	rx_rd_ptr=0;
	rx_wr_ptr=0;

	UART__TE=1;
	UART__RE=1;

}

// UART|[g1LN^M
void putc_rs(unsigned int c)
{
	while(UART__TI==0)
		;
	UART_TB=c;
}

// UART|[gɕ񑗐M
void puts_rs(char *str)
{
	while (*str!=0)
		putc_rs(*(str++));
}

// UART|[gPLN^M
// Mf[^Ȃ -1Ԃ
int getc_rs(void)
{
	int c;

	if (rx_rd_ptr!=rx_wr_ptr)
	{
		c=rx_buffer[rx_rd_ptr++];
		if (rx_rd_ptr>=RX_BUF_SIZE)
			rx_rd_ptr=0;
	}
	else
		c=-1;

	return c;
}

// CvO
// Mf[^LCDɕ\
void main(void)
{
	int c;

	LCD_init();			// LCD
	LCD_cursor(3);		// LCDJ[\\
	UART_init();		// UART

	ei();				// 荞݋

	puts_rs("\r\n<<Welcome to ATB-R8CQ_EX. Receive data display to LCD!>>\r\n");	// ^CgM

	while(1)
	{
		if((c=getc_rs())!=-1)			// Mf[^?
		{
			if (c=='\r')				// Enter(CarrigeRreturn)?
				LCD_puts("\r\n");
			else
				LCD_putc(c & 0xff);		// Mf[^LCDɕ\
		}
	}
}
