// ****  sample programs for ATB-R8CQ_EX (c)AT-Laboratory  ****
// vO: UART_LCD.C
//  쐬t   : 2005/3/1
// vO̓e: UARTMLCD\TvvO
//
// ****  sample programs for ATB-R8CQ_EX (c)AT-Laboratory  ****
// vO: LCD.C
//  쐬t   : 2005/3/10
// vO̓e:LCDW[ɕ\
//
//@L2gݍ킹
//
//  UARTMf[^LCDɕ\܂B
// 
// ʐM|[gUART0|[g(COM0RS232CRlN^)
// ʐMp[^́A19200bps/8rbgf[^/peBȂ/Xgbvrbg1
// ύX̓\[X UART_init()֐ōs܂B

#include "R8C15.h"
//#include "std_lcd.h"


#define UART_MR		SFR_U0MR
#define UART__RE	SFR_U0_RE
#define UART__TE	SFR_U0_TE
#define UART__RI	SFR_U0_RI
#define UART__TI	SFR_U0_TI

#define UART_C0		SFR_U0C0
#define UART_C1		SFR_U0C1
#define UART_BRG	SFR_U0BRG
#define UART_RB		SFR_U0RB
#define UART_TB		SFR_U0TB

#define UART_RIC	SFR_U0RIC
#define UART_TIC	SFR_U0TIC


			// 20MHz	16M
#define	BRG_57600	21	//	16
#define CNTR_57600	0	//	0
#define	BRG_38400	32	//	25
#define CNTR_38400	0	//	0
#define	BRG_19200	64	//	51
#define CNTR_19200	0	//	0
#define	BRG_9600	129	//	103
#define CNTR_9600	0	//	0
#define	BRG_4800	32	//	207
#define CNTR_4800	1	//	0


#define PAR_NONE	0
#define PAR_ODD		0b01000000
#define PAR_EVEN	0b01100000

#define STOP_1		0b00000000
#define STOP_2		0b00010000

#define BIT_7		0b00000100
#define BIT_8		0b00000101
#define BIT_9		0b00000110

// vg^Cv錾
void UART_init(void);
void putc_rs(unsigned int c);
void puts_rs(char *str);
int getc_rs(void);

// O[oϐ錾
#define RX_BUF_SIZE	100
unsigned char rx_buffer[RX_BUF_SIZE];	// MOobt@[
unsigned char rx_rd_ptr;		// Mǂݎ|C^[
unsigned char rx_wr_ptr;		// M݃|C^[

// U0|[g̏ꍇ̎M荞ݏ
void u0_rx_int(void)
#pragma interrupt u0_rx_int (vect=18)
{

	rx_buffer[rx_wr_ptr]=(unsigned char)(UART_RB & 0xff);
	rx_wr_ptr++;
	if (rx_wr_ptr>=RX_BUF_SIZE)
		rx_wr_ptr=0;

}


//
// UARTݒ 19200bps 8bits parity:none stop:1
void UART_init(void)
{
	UART_C0=  CNTR_19200;
	UART_BRG= BRG_19200;
	UART_MR=  PAR_NONE | STOP_1 | BIT_8;
	UART_RIC=6;		// INT LEVEL
	rx_rd_ptr=0;
	rx_wr_ptr=0;

	UART__TE=1;
	UART__RE=1;

}

// UART|[g1LN^M
void putc_rs(unsigned int c)
{
	while(UART__TI==0)
		;
	UART_TB=c;
}

// UART|[gɕ񑗐M
void puts_rs(char *str)
{
	while (*str!=0)
		putc_rs(*(str++));
}

// UART|[gPLN^M
// Mf[^Ȃ -1Ԃ
int getc_rs(void)
{
	int c;

	if (rx_rd_ptr!=rx_wr_ptr)
	{
		c=rx_buffer[rx_rd_ptr++];
		if (rx_rd_ptr>=RX_BUF_SIZE)
			rx_rd_ptr=0;
	}
	else
		c=-1;

	return c;
}

// vg^Cv錾
void DelayMs(unsigned int cnt);
void lcd_write(unsigned char c);
void lcd_clear(void);
void lcd_puts(const char * s);
void lcd_putc(char c);
void lcd_goto(unsigned char pos);
void lcd_init(void);

// LCD[qzu
#define LCD_RS		SFR_P3_5
#define LCD_E		SFR_P3_4
//#define  LCD_D4	SFR_P1_1
//#define  LCD_D5	SFR_P1_2
//#define  LCD_D6	SFR_P1_6
//#define  LCD_D7	SFR_P1_7

#define	LCD_DATA_MASK	0b00111001

#define	LCD_STROBE	((LCD_E = 1),(LCD_E=0))

// 10uS҂p}N` (nl02621܂)
#define	Delay10Us(x)	{_asm("push.w R3"); _asm("mov.w #"#x"*25,R3"); _asm("sbjnz.w #1,R3,$"); _asm("pop.w R3");}

// 1mS҂֐
void DelayMs(unsigned int cnt)
{
	unsigned int i;
	for (i=0;i<cnt;i++)
		Delay10Us(100);		// 10mS҂[vJEg 10uS*100=1mS
}

// LCD_D4-D7prbgf[^ϊe[u
static unsigned char bit_cnv[]=
{	0b00000000,0b00000010,0b00000100,0b00000110,0b01000000,0b01000010,0b01000100,0b01000110,
	0b10000000,0b10000010,0b10000100,0b10000110,0b11000000,0b11000010,0b11000100,0b11000110 };

// 4rbg[hLCDɏ
void lcd_write(unsigned char c)
{
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[(c >> 4)];
	LCD_STROBE;
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[(c & 0x0F)];
	LCD_STROBE;
	Delay10Us(4);
}

// \NA
void lcd_clear(void)
{
	LCD_RS=0;
	lcd_write(0x1);
	DelayMs(2);
}

// XgOLCD\
void lcd_puts(const char * s)
{
	LCD_RS=1;	// write characters
	while(*s)
		lcd_write(*s++);
}

// PLN^LCD\/
void lcd_putc(char c)
{
	LCD_RS=1;	// write characters
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[(c >> 4)];
	LCD_STROBE;
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[(c & 0x0F)];
	LCD_STROBE;
	Delay10Us(4);
}

// \ʒuw
void lcd_goto(unsigned char pos)
{
	LCD_RS=0;	// write control bytes
	lcd_write(0x80+pos);
}

// LCD
void lcd_init(void)
{
	SFR_P1D=~LCD_DATA_MASK;		// LCDp|[gSo
	SFR_P3D_5=1;			// LCD_RS
	SFR_P3D_4=1;			// LCD_E

	LCD_RS=0;	// write control bytes
	DelayMs(40);	// power on delay 40mS
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[3];	// attention!
	LCD_STROBE;
	DelayMs(5);
	LCD_STROBE;
	Delay10Us(10);
	LCD_STROBE;
	DelayMs(5);
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[2];	// set 4 bit mode
	LCD_STROBE;
	Delay10Us(4);
	lcd_write(0x28);	// 4 bit mode, 1/16 duty, 5x8 font
	lcd_write(0x08);	// display off
	lcd_write(0x0F);	// display on, blink curson on
	lcd_write(0x06);	// entry mode
}


// CvO
// Mf[^LCDɕ\
void main(void)
{
	int c,lastROW;

	lcd_init();			// LCD
	lastROW = 0;
	UART_init();		// UART

	ei();				// 荞݋

	puts_rs("\r\n<<Welcome to ATB-R8CQ_EX. Receive data display to LCD!>>\r\n");	// ^CgM

	while(1)
	{
		if((c=getc_rs())!=-1)			// Mf[^?
		{
			if (c=='\r')				// Enter(CR)?
				{
				if (lastROW) lastROW =0 ;	//1sڂɃZbg
				else lastROW =1 ;			//2sڂɃZbg
				lcd_goto (0x40*lastROW);
				}
			else
				lcd_putc(c & 0xff);		// Mf[^LCDɕ\
		}
	}
}
